Index: uspace/app/uidemo/uidemo.c
===================================================================
--- uspace/app/uidemo/uidemo.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/app/uidemo/uidemo.c	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -40,5 +40,4 @@
 #include <str.h>
 #include <ui/entry.h>
-#include <ui/filedialog.h>
 #include <ui/fixed.h>
 #include <ui/image.h>
@@ -49,5 +48,4 @@
 #include <ui/msgdialog.h>
 #include <ui/pbutton.h>
-#include <ui/promptdialog.h>
 #include <ui/resource.h>
 #include <ui/ui.h>
@@ -87,28 +85,6 @@
 };
 
-static void uidemo_file_load(ui_menu_entry_t *, void *);
 static void uidemo_file_message(ui_menu_entry_t *, void *);
 static void uidemo_file_exit(ui_menu_entry_t *, void *);
-static void uidemo_edit_modify(ui_menu_entry_t *, void *);
-
-static void file_dialog_bok(ui_file_dialog_t *, void *, const char *);
-static void file_dialog_bcancel(ui_file_dialog_t *, void *);
-static void file_dialog_close(ui_file_dialog_t *, void *);
-
-static ui_file_dialog_cb_t file_dialog_cb = {
-	.bok = file_dialog_bok,
-	.bcancel = file_dialog_bcancel,
-	.close = file_dialog_close
-};
-
-static void prompt_dialog_bok(ui_prompt_dialog_t *, void *, const char *);
-static void prompt_dialog_bcancel(ui_prompt_dialog_t *, void *);
-static void prompt_dialog_close(ui_prompt_dialog_t *, void *);
-
-static ui_prompt_dialog_cb_t prompt_dialog_cb = {
-	.bok = prompt_dialog_bok,
-	.bcancel = prompt_dialog_bcancel,
-	.close = prompt_dialog_close
-};
 
 static void msg_dialog_button(ui_msg_dialog_t *, void *, unsigned);
@@ -120,11 +96,4 @@
 };
 
-/** Horizontal alignment selected by each radio button */
-static const gfx_halign_t uidemo_halign[3] = {
-	gfx_halign_left,
-	gfx_halign_center,
-	gfx_halign_right
-};
-
 /** Window close button was clicked.
  *
@@ -153,8 +122,10 @@
 		if (rc != EOK)
 			printf("Error changing entry text.\n");
+		(void) ui_entry_paint(demo->entry);
 	} else {
 		rc = ui_entry_set_text(demo->entry, "Cancel pressed");
 		if (rc != EOK)
 			printf("Error changing entry text.\n");
+		(void) ui_entry_paint(demo->entry);
 	}
 }
@@ -168,6 +139,17 @@
 {
 	ui_demo_t *demo = (ui_demo_t *) arg;
-
-	ui_entry_set_read_only(demo->entry, enable);
+	errno_t rc;
+
+	if (enable) {
+		rc = ui_entry_set_text(demo->entry, "Checked");
+		if (rc != EOK)
+			printf("Error changing entry text.\n");
+		(void) ui_entry_paint(demo->entry);
+	} else {
+		rc = ui_entry_set_text(demo->entry, "Unchecked");
+		if (rc != EOK)
+			printf("Error changing entry text.\n");
+		(void) ui_entry_paint(demo->entry);
+	}
 }
 
@@ -181,7 +163,10 @@
 {
 	ui_demo_t *demo = (ui_demo_t *) garg;
-	gfx_halign_t halign = *(gfx_halign_t *) barg;
-
-	ui_entry_set_halign(demo->entry, halign);
+	const char *text = (const char *) barg;
+	errno_t rc;
+
+	rc = ui_entry_set_text(demo->entry, text);
+	if (rc != EOK)
+		printf("Error changing entry text.\n");
 	(void) ui_entry_paint(demo->entry);
 }
@@ -215,55 +200,5 @@
 }
 
-/** Display a message window.
- *
- * @param demo UI demo
- * @param caption Window caption
- * @param text Message text
- */
-static void uidemo_show_message(ui_demo_t *demo, const char *caption,
-    const char *text)
-{
-	ui_msg_dialog_params_t mdparams;
-	ui_msg_dialog_t *dialog;
-	errno_t rc;
-
-	ui_msg_dialog_params_init(&mdparams);
-	mdparams.caption = caption;
-	mdparams.text = text;
-
-	rc = ui_msg_dialog_create(demo->ui, &mdparams, &dialog);
-	if (rc != EOK) {
-		printf("Error creating message dialog.\n");
-		return;
-	}
-
-	ui_msg_dialog_set_cb(dialog, &msg_dialog_cb, &demo);
-}
-
-/** File / Load menu entry selected.
- *
- * @param mentry Menu entry
- * @param arg Argument (demo)
- */
-static void uidemo_file_load(ui_menu_entry_t *mentry, void *arg)
-{
-	ui_demo_t *demo = (ui_demo_t *) arg;
-	ui_file_dialog_params_t fdparams;
-	ui_file_dialog_t *dialog;
-	errno_t rc;
-
-	ui_file_dialog_params_init(&fdparams);
-	fdparams.caption = "Load File";
-
-	rc = ui_file_dialog_create(demo->ui, &fdparams, &dialog);
-	if (rc != EOK) {
-		printf("Error creating message dialog.\n");
-		return;
-	}
-
-	ui_file_dialog_set_cb(dialog, &file_dialog_cb, demo);
-}
-
-/** File / Message menu entry selected.
+/** File/message menu entry selected.
  *
  * @param mentry Menu entry
@@ -288,7 +223,8 @@
 
 	ui_msg_dialog_set_cb(dialog, &msg_dialog_cb, &demo);
-}
-
-/** File / Exit menu entry selected.
+
+}
+
+/** File/exit menu entry selected.
  *
  * @param mentry Menu entry
@@ -300,139 +236,4 @@
 
 	ui_quit(demo->ui);
-}
-
-/** Edit / Modify menu entry selected.
- *
- * @param mentry Menu entry
- * @param arg Argument (demo)
- */
-static void uidemo_edit_modify(ui_menu_entry_t *mentry, void *arg)
-{
-	ui_demo_t *demo = (ui_demo_t *) arg;
-	ui_prompt_dialog_params_t pdparams;
-	ui_prompt_dialog_t *dialog;
-	errno_t rc;
-
-	ui_prompt_dialog_params_init(&pdparams);
-	pdparams.caption = "Modify Entry Text";
-	pdparams.prompt = "Enter New Text";
-
-	rc = ui_prompt_dialog_create(demo->ui, &pdparams, &dialog);
-	if (rc != EOK) {
-		printf("Error creating message dialog.\n");
-		return;
-	}
-
-	ui_prompt_dialog_set_cb(dialog, &prompt_dialog_cb, demo);
-}
-
-/** File dialog OK button press.
- *
- * @param dialog File dialog
- * @param arg Argument (ui_demo_t *)
- * @param fname File name
- */
-static void file_dialog_bok(ui_file_dialog_t *dialog, void *arg,
-    const char *fname)
-{
-	ui_demo_t *demo = (ui_demo_t *) arg;
-	char buf[128];
-	char *p;
-	FILE *f;
-
-	ui_file_dialog_destroy(dialog);
-
-	f = fopen(fname, "rt");
-	if (f == NULL) {
-		uidemo_show_message(demo, "Error", "Error opening file.");
-		return;
-	}
-
-	p = fgets(buf, sizeof(buf), f);
-	if (p == NULL) {
-		uidemo_show_message(demo, "Error", "Error reading file.");
-		fclose(f);
-		return;
-	}
-
-	/* Cut string off at the first non-printable character */
-	p = buf;
-	while (*p != '\0') {
-		if (*p < ' ') {
-			*p = '\0';
-			break;
-		}
-		++p;
-	}
-
-	ui_entry_set_text(demo->entry, buf);
-	fclose(f);
-}
-
-/** File dialog cancel button press.
- *
- * @param dialog File dialog
- * @param arg Argument (ui_demo_t *)
- */
-static void file_dialog_bcancel(ui_file_dialog_t *dialog, void *arg)
-{
-	ui_demo_t *demo = (ui_demo_t *) arg;
-
-	(void) demo;
-	ui_file_dialog_destroy(dialog);
-}
-
-/** File dialog close request.
- *
- * @param dialog File dialog
- * @param arg Argument (ui_demo_t *)
- */
-static void file_dialog_close(ui_file_dialog_t *dialog, void *arg)
-{
-	ui_demo_t *demo = (ui_demo_t *) arg;
-
-	(void) demo;
-	ui_file_dialog_destroy(dialog);
-}
-
-/** Prompt dialog OK button press.
- *
- * @param dialog Prompt dialog
- * @param arg Argument (ui_demo_t *)
- * @param text Submitted text
- */
-static void prompt_dialog_bok(ui_prompt_dialog_t *dialog, void *arg,
-    const char *text)
-{
-	ui_demo_t *demo = (ui_demo_t *) arg;
-
-	ui_prompt_dialog_destroy(dialog);
-	ui_entry_set_text(demo->entry, text);
-}
-
-/** Prompt dialog cancel button press.
- *
- * @param dialog File dialog
- * @param arg Argument (ui_demo_t *)
- */
-static void prompt_dialog_bcancel(ui_prompt_dialog_t *dialog, void *arg)
-{
-	ui_demo_t *demo = (ui_demo_t *) arg;
-
-	(void) demo;
-	ui_prompt_dialog_destroy(dialog);
-}
-
-/** Prompt dialog close request.
- *
- * @param dialog File dialog
- * @param arg Argument (ui_demo_t *)
- */
-static void prompt_dialog_close(ui_prompt_dialog_t *dialog, void *arg)
-{
-	ui_demo_t *demo = (ui_demo_t *) arg;
-
-	(void) demo;
-	ui_prompt_dialog_destroy(dialog);
 }
 
@@ -479,11 +280,8 @@
 	gfx_coord2_t off;
 	ui_menu_entry_t *mmsg;
-	ui_menu_entry_t *mload;
 	ui_menu_entry_t *mfoo;
 	ui_menu_entry_t *mbar;
 	ui_menu_entry_t *mfoobar;
-	ui_menu_entry_t *msep;
 	ui_menu_entry_t *mexit;
-	ui_menu_entry_t *mmodify;
 	ui_menu_entry_t *mabout;
 	errno_t rc;
@@ -506,6 +304,6 @@
 		params.rect.p0.x = 0;
 		params.rect.p0.y = 0;
-		params.rect.p1.x = 44;
-		params.rect.p1.y = 21;
+		params.rect.p1.x = 80;
+		params.rect.p1.y = 25;
 	} else {
 		params.rect.p0.x = 0;
@@ -553,12 +351,4 @@
 	ui_menu_entry_set_cb(mmsg, uidemo_file_message, (void *) &demo);
 
-	rc = ui_menu_entry_create(demo.mfile, "Load", "", &mload);
-	if (rc != EOK) {
-		printf("Error creating menu.\n");
-		return rc;
-	}
-
-	ui_menu_entry_set_cb(mload, uidemo_file_load, (void *) &demo);
-
 	rc = ui_menu_entry_create(demo.mfile, "Foo", "Ctrl-Alt-Del", &mfoo);
 	if (rc != EOK) {
@@ -579,5 +369,5 @@
 	}
 
-	rc = ui_menu_entry_sep_create(demo.mfile, &msep);
+	rc = ui_menu_entry_sep_create(demo.mfile, &mexit);
 	if (rc != EOK) {
 		printf("Error creating menu.\n");
@@ -598,12 +388,4 @@
 		return rc;
 	}
-
-	rc = ui_menu_entry_create(demo.medit, "Modify", "", &mmodify);
-	if (rc != EOK) {
-		printf("Error creating menu.\n");
-		return rc;
-	}
-
-	ui_menu_entry_set_cb(mmodify, uidemo_edit_modify, (void *) &demo);
 
 	rc = ui_menu_create(demo.mbar, "Preferences", &demo.mpreferences);
@@ -628,7 +410,7 @@
 	if (ui_is_textmode(ui)) {
 		rect.p0.x = 1;
-		rect.p0.y = 1;
-		rect.p1.x = 43;
-		rect.p1.y = 2;
+		rect.p0.y = 2;
+		rect.p1.x = 79;
+		rect.p1.y = 3;
 	} else {
 		rect.p0.x = 4;
@@ -651,17 +433,8 @@
 	}
 
-	/* FIXME: Auto layout */
-	if (ui_is_textmode(ui)) {
-		rect.p0.x = 2;
-		rect.p0.y = 3;
-		rect.p1.x = 42;
-		rect.p1.y = 4;
-	} else {
-		rect.p0.x = 15;
-		rect.p0.y = 53;
-		rect.p1.x = 205;
-		rect.p1.y = 78;
-	}
-
+	rect.p0.x = 15;
+	rect.p0.y = 53;
+	rect.p1.x = 205;
+	rect.p1.y = 78;
 	ui_entry_set_rect(demo.entry, &rect);
 	ui_entry_set_halign(demo.entry, gfx_halign_center);
@@ -679,17 +452,8 @@
 	}
 
-	/* FIXME: Auto layout */
-	if (ui_is_textmode(ui)) {
-		rect.p0.x = 2;
-		rect.p0.y = 5;
-		rect.p1.x = 42;
-		rect.p1.y = 6;
-	} else {
-		rect.p0.x = 60;
-		rect.p0.y = 88;
-		rect.p1.x = 160;
-		rect.p1.y = 101;
-	}
-
+	rect.p0.x = 60;
+	rect.p0.y = 88;
+	rect.p1.x = 160;
+	rect.p1.y = 101;
 	ui_label_set_rect(demo.label, &rect);
 	ui_label_set_halign(demo.label, gfx_halign_center);
@@ -709,17 +473,8 @@
 	ui_pbutton_set_cb(demo.pb1, &pbutton_cb, (void *) &demo);
 
-	/* FIXME: Auto layout */
-	if (ui_is_textmode(ui)) {
-		rect.p0.x = 2;
-		rect.p0.y = 7;
-		rect.p1.x = 12;
-		rect.p1.y = 8;
-	} else {
-		rect.p0.x = 15;
-		rect.p0.y = 111;
-		rect.p1.x = 105;
-		rect.p1.y = 139;
-	}
-
+	rect.p0.x = 15;
+	rect.p0.y = 111;
+	rect.p1.x = 105;
+	rect.p1.y = 139;
 	ui_pbutton_set_rect(demo.pb1, &rect);
 
@@ -740,16 +495,8 @@
 	ui_pbutton_set_cb(demo.pb2, &pbutton_cb, (void *) &demo);
 
-	if (ui_is_textmode(ui)) {
-		rect.p0.x = 32;
-		rect.p0.y = 7;
-		rect.p1.x = 42;
-		rect.p1.y = 8;
-	} else {
-		rect.p0.x = 115;
-		rect.p0.y = 111;
-		rect.p1.x = 205;
-		rect.p1.y = 139;
-	}
-
+	rect.p0.x = 115;
+	rect.p0.y = 111;
+	rect.p1.x = 205;
+	rect.p1.y = 139;
 	ui_pbutton_set_rect(demo.pb2, &rect);
 
@@ -761,15 +508,8 @@
 
 	gfx_bitmap_params_init(&bparams);
-	if (ui_is_textmode(ui)) {
-		bparams.rect.p0.x = 0;
-		bparams.rect.p0.y = 0;
-		bparams.rect.p1.x = 40;
-		bparams.rect.p1.y = 2;
-	} else {
-		bparams.rect.p0.x = 0;
-		bparams.rect.p0.y = 0;
-		bparams.rect.p1.x = 188;
-		bparams.rect.p1.y = 24;
-	}
+	bparams.rect.p0.x = 0;
+	bparams.rect.p0.y = 0;
+	bparams.rect.p1.x = 188;
+	bparams.rect.p1.y = 24;
 
 	rc = gfx_bitmap_create(gc, &bparams, NULL, &bitmap);
@@ -787,22 +527,13 @@
 	}
 
-	if (ui_is_textmode(ui)) {
-		off.x = 2;
-		off.y = 9;
-	} else {
-		off.x = 15;
-		off.y = 155;
-	}
-
+	off.x = 15;
+	off.y = 155;
 	gfx_rect_translate(&off, &bparams.rect, &rect);
 
 	/* Adjust for frame width (2 x 1 pixel) */
-	if (!ui_is_textmode(ui)) {
-		ui_image_set_flags(demo.image, ui_imgf_frame);
-		rect.p1.x += 2;
-		rect.p1.y += 2;
-	}
-
+	rect.p1.x += 2;
+	rect.p1.y += 2;
 	ui_image_set_rect(demo.image, &rect);
+	ui_image_set_flags(demo.image, ui_imgf_frame);
 
 	rc = ui_fixed_add(demo.fixed, ui_image_ctl(demo.image));
@@ -812,5 +543,5 @@
 	}
 
-	rc = ui_checkbox_create(ui_res, "Read only", &demo.checkbox);
+	rc = ui_checkbox_create(ui_res, "Check me", &demo.checkbox);
 	if (rc != EOK) {
 		printf("Error creating check box.\n");
@@ -820,17 +551,8 @@
 	ui_checkbox_set_cb(demo.checkbox, &checkbox_cb, (void *) &demo);
 
-	/* FIXME: Auto layout */
-	if (ui_is_textmode(ui)) {
-		rect.p0.x = 2;
-		rect.p0.y = 12;
-		rect.p1.x = 12;
-		rect.p1.y = 13;
-	} else {
-		rect.p0.x = 15;
-		rect.p0.y = 190;
-		rect.p1.x = 140;
-		rect.p1.y = 210;
-	}
-
+	rect.p0.x = 15;
+	rect.p0.y = 190;
+	rect.p1.x = 140;
+	rect.p1.y = 210;
 	ui_checkbox_set_rect(demo.checkbox, &rect);
 
@@ -847,6 +569,6 @@
 	}
 
-	rc = ui_rbutton_create(demo.rbgroup, "Left", (void *) &uidemo_halign[0],
-	    &demo.rbleft);
+	rc = ui_rbutton_create(demo.rbgroup, "Option 1", (void *) "First",
+	    &demo.rb1);
 	if (rc != EOK) {
 		printf("Error creating radio button.\n");
@@ -857,26 +579,18 @@
 	    (void *) &demo);
 
-	/* FIXME: Auto layout */
-	if (ui_is_textmode(ui)) {
-		rect.p0.x = 2;
-		rect.p0.y = 14;
-		rect.p1.x = 12;
-		rect.p1.y = 15;
-	} else {
-		rect.p0.x = 15;
-		rect.p0.y = 220;
-		rect.p1.x = 140;
-		rect.p1.y = 240;
-	}
-	ui_rbutton_set_rect(demo.rbleft, &rect);
-
-	rc = ui_fixed_add(demo.fixed, ui_rbutton_ctl(demo.rbleft));
-	if (rc != EOK) {
-		printf("Error adding control to layout.\n");
-		return rc;
-	}
-
-	rc = ui_rbutton_create(demo.rbgroup, "Center", (void *) &uidemo_halign[1],
-	    &demo.rbcenter);
+	rect.p0.x = 15;
+	rect.p0.y = 220;
+	rect.p1.x = 140;
+	rect.p1.y = 240;
+	ui_rbutton_set_rect(demo.rb1, &rect);
+
+	rc = ui_fixed_add(demo.fixed, ui_rbutton_ctl(demo.rb1));
+	if (rc != EOK) {
+		printf("Error adding control to layout.\n");
+		return rc;
+	}
+
+	rc = ui_rbutton_create(demo.rbgroup, "Option 2", (void *) "Second",
+	    &demo.rb2);
 	if (rc != EOK) {
 		printf("Error creating radio button.\n");
@@ -884,27 +598,18 @@
 	}
 
-	/* FIXME: Auto layout */
-	if (ui_is_textmode(ui)) {
-		rect.p0.x = 2;
-		rect.p0.y = 15;
-		rect.p1.x = 12;
-		rect.p1.y = 16;
-	} else {
-		rect.p0.x = 15;
-		rect.p0.y = 250;
-		rect.p1.x = 140;
-		rect.p1.y = 270;
-	}
-	ui_rbutton_set_rect(demo.rbcenter, &rect);
-	ui_rbutton_select(demo.rbcenter);
-
-	rc = ui_fixed_add(demo.fixed, ui_rbutton_ctl(demo.rbcenter));
-	if (rc != EOK) {
-		printf("Error adding control to layout.\n");
-		return rc;
-	}
-
-	rc = ui_rbutton_create(demo.rbgroup, "Right", (void *) &uidemo_halign[2],
-	    &demo.rbright);
+	rect.p0.x = 15;
+	rect.p0.y = 250;
+	rect.p1.x = 140;
+	rect.p1.y = 270;
+	ui_rbutton_set_rect(demo.rb2, &rect);
+
+	rc = ui_fixed_add(demo.fixed, ui_rbutton_ctl(demo.rb2));
+	if (rc != EOK) {
+		printf("Error adding control to layout.\n");
+		return rc;
+	}
+
+	rc = ui_rbutton_create(demo.rbgroup, "Option 3", (void *) "Third",
+	    &demo.rb3);
 	if (rc != EOK) {
 		printf("Error creating radio button.\n");
@@ -912,19 +617,11 @@
 	}
 
-	/* FIXME: Auto layout */
-	if (ui_is_textmode(ui)) {
-		rect.p0.x = 2;
-		rect.p0.y = 16;
-		rect.p1.x = 12;
-		rect.p1.y = 17;
-	} else {
-		rect.p0.x = 15;
-		rect.p0.y = 280;
-		rect.p1.x = 140;
-		rect.p1.y = 300;
-	}
-	ui_rbutton_set_rect(demo.rbright, &rect);
-
-	rc = ui_fixed_add(demo.fixed, ui_rbutton_ctl(demo.rbright));
+	rect.p0.x = 15;
+	rect.p0.y = 280;
+	rect.p1.x = 140;
+	rect.p1.y = 300;
+	ui_rbutton_set_rect(demo.rb3, &rect);
+
+	rc = ui_fixed_add(demo.fixed, ui_rbutton_ctl(demo.rb3));
 	if (rc != EOK) {
 		printf("Error adding control to layout.\n");
@@ -940,17 +637,8 @@
 	ui_slider_set_cb(demo.slider, &slider_cb, (void *) &demo);
 
-	/* FIXME: Auto layout */
-	if (ui_is_textmode(ui)) {
-		rect.p0.x = 2;
-		rect.p0.y = 18;
-		rect.p1.x = 12;
-		rect.p1.y = 19;
-	} else {
-		rect.p0.x = 15;
-		rect.p0.y = 310;
-		rect.p1.x = 130;
-		rect.p1.y = 330;
-	}
-
+	rect.p0.x = 15;
+	rect.p0.y = 310;
+	rect.p1.x = 130;
+	rect.p1.y = 330;
 	ui_slider_set_rect(demo.slider, &rect);
 
@@ -1005,5 +693,5 @@
 			k = i * i + j * j;
 			pixelmap_put_pixel(&pixelmap, i, j,
-			    PIXEL(0, k, k, 255 - k));
+			    PIXEL(255, k, k, 255 - k));
 		}
 	}
Index: uspace/app/uidemo/uidemo.h
===================================================================
--- uspace/app/uidemo/uidemo.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/app/uidemo/uidemo.h	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -67,7 +67,7 @@
 	ui_checkbox_t *checkbox;
 	ui_rbutton_group_t *rbgroup;
-	ui_rbutton_t *rbleft;
-	ui_rbutton_t *rbcenter;
-	ui_rbutton_t *rbright;
+	ui_rbutton_t *rb1;
+	ui_rbutton_t *rb2;
+	ui_rbutton_t *rb3;
 	ui_slider_t *slider;
 } ui_demo_t;
Index: uspace/drv/char/i8042/i8042.h
===================================================================
--- uspace/drv/char/i8042/i8042.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/drv/char/i8042/i8042.h	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -1,6 +1,6 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
  * Copyright (c) 2006 Josef Cejka
  * Copyright (c) 2011 Jan Vesely
+ * Copyright (c) 2017 Jiri Svoboda
  * All rights reserved.
  *
@@ -48,8 +48,5 @@
 #define NAME  "i8042"
 
-/** Buffer needs to be large enough for rate at which keyboard or mouse
- * produces data (mouse produces data at faster rate).
- */
-#define BUFFER_SIZE  64
+#define BUFFER_SIZE  12
 
 /** i8042 HW I/O interface */
Index: uspace/drv/meson.build
===================================================================
--- uspace/drv/meson.build	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/drv/meson.build	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -78,5 +78,4 @@
 	'platform/amdm37x',
 	'platform/arm64virt',
-	'platform/hikey960',
 	'platform/icp',
 	'platform/mac',
Index: uspace/lib/c/generic/io/asprintf.c
===================================================================
--- uspace/lib/c/generic/io/asprintf.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/c/generic/io/asprintf.c	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -89,5 +89,5 @@
 	va_end(args2);
 
-	if (ret >= 0) {
+	if (ret > 0) {
 		*strp = malloc(ret + 1);
 		if (*strp == NULL)
Index: uspace/lib/c/generic/io/console.c
===================================================================
--- uspace/lib/c/generic/io/console.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/c/generic/io/console.c	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -290,4 +290,6 @@
 	exch = async_exchange_begin(ctrl->output_sess);
 	req = async_send_2(exch, CONSOLE_MAP, cols, rows, &answer);
+	if (rc != EOK)
+		goto error;
 
 	asize = PAGES2SIZE(SIZE2PAGES(cols * rows * sizeof(charfield_t)));
Index: uspace/lib/c/include/adt/list.h
===================================================================
--- uspace/lib/c/include/adt/list.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/c/include/adt/list.h	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -89,5 +89,5 @@
 
 #define list_foreach(list, member, itype, iterator) \
-	for (itype *iterator = NULL; iterator == NULL; iterator = (itype *) sizeof(itype)) \
+	for (itype *iterator = NULL; iterator == NULL; iterator = &((itype *) NULL)[1]) \
 		for (link_t *_link = (list).head.next; \
 		    iterator = list_get_instance(_link, itype, member), \
@@ -95,5 +95,5 @@
 
 #define list_foreach_rev(list, member, itype, iterator) \
-	for (itype *iterator = NULL; iterator == NULL; iterator = (itype *) sizeof(itype)) \
+	for (itype *iterator = NULL; iterator == NULL; iterator = &((itype *) NULL)[1]) \
 		for (link_t *_link = (list).head.prev; \
 		    iterator = list_get_instance(_link, itype, member), \
Index: uspace/lib/congfx/src/console.c
===================================================================
--- uspace/lib/congfx/src/console.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/congfx/src/console.c	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -57,7 +57,4 @@
 static errno_t console_gc_bitmap_render(void *, gfx_rect_t *, gfx_coord2_t *);
 static errno_t console_gc_bitmap_get_alloc(void *, gfx_bitmap_alloc_t *);
-static errno_t console_gc_cursor_get_pos(void *, gfx_coord2_t *);
-static errno_t console_gc_cursor_set_pos(void *, gfx_coord2_t *);
-static errno_t console_gc_cursor_set_visible(void *, bool);
 
 gfx_context_ops_t console_gc_ops = {
@@ -69,46 +66,6 @@
 	.bitmap_destroy = console_gc_bitmap_destroy,
 	.bitmap_render = console_gc_bitmap_render,
-	.bitmap_get_alloc = console_gc_bitmap_get_alloc,
-	.cursor_get_pos = console_gc_cursor_get_pos,
-	.cursor_set_pos = console_gc_cursor_set_pos,
-	.cursor_set_visible = console_gc_cursor_set_visible
+	.bitmap_get_alloc = console_gc_bitmap_get_alloc
 };
-
-/** Convert pixel value to charfield.
- *
- * On the bottom of this function lies a big big hack. In the absence
- * of support for different color formats (FIX ME!), here's a single
- * format that can represent both 3x8bit RGB and 24-bit characters
- * with 8-bit EGA attributes (i.e. we can specify the foreground and
- * background colors individually).
- *
- * A    R   G   B
- * 0    red grn blu  24-bit color
- * attr c2  c1  c0   attribute + 24-bit character
- */
-static void console_gc_pix_to_charfield(pixel_t clr, charfield_t *ch)
-{
-	uint8_t attr;
-
-	if ((clr >> 24) == 0) {
-		/* RGB (no text) */
-		ch->ch = 0;
-		ch->flags = CHAR_FLAG_DIRTY;
-		ch->attrs.type = CHAR_ATTR_RGB;
-		ch->attrs.val.rgb.fgcolor = clr ^ 0xffffff;
-		ch->attrs.val.rgb.bgcolor = clr;
-	} else {
-		/* EGA attributes (with text) */
-		attr = clr >> 24;
-		ch->ch = clr & 0xffffff;
-		ch->flags = CHAR_FLAG_DIRTY;
-		ch->attrs.type = CHAR_ATTR_INDEX;
-		ch->attrs.val.index.fgcolor = attr & 0x7;
-		ch->attrs.val.index.bgcolor = (attr >> 4) & 0x7;
-		ch->attrs.val.index.attr =
-		    ((attr & 0x8) ? CATTR_BRIGHT : 0) +
-		    ((attr & 0x80) ? CATTR_BLINK : 0);
-	}
-}
 
 /** Set clipping rectangle on console GC.
@@ -144,5 +101,5 @@
 	console_gc_t *cgc = (console_gc_t *) arg;
 
-	cgc->clr = PIXEL(color->attr, color->r >> 8, color->g >> 8, color->b >> 8);
+	cgc->clr = PIXEL(0, color->r >> 8, color->g >> 8, color->b >> 8);
 	return EOK;
 }
@@ -168,5 +125,9 @@
 	cols = cgc->rect.p1.x - cgc->rect.p0.x;
 
-	console_gc_pix_to_charfield(cgc->clr, &ch);
+	ch.ch = cgc->clr >> 24;
+	ch.flags = CHAR_FLAG_DIRTY;
+	ch.attrs.type = CHAR_ATTR_RGB;
+	ch.attrs.val.rgb.fgcolor = cgc->clr ^ 0xffffff;
+	ch.attrs.val.rgb.bgcolor = cgc->clr;
 
 	for (y = crect.p0.y; y < crect.p1.y; y++) {
@@ -407,5 +368,10 @@
 				    y - offs.y - cbm->rect.p0.y);
 
-				console_gc_pix_to_charfield(clr, &ch);
+				ch.ch = clr >> 24;
+				ch.flags = CHAR_FLAG_DIRTY;
+				ch.attrs.type = CHAR_ATTR_RGB;
+				ch.attrs.val.rgb.fgcolor = clr ^ 0xffffff;
+				ch.attrs.val.rgb.bgcolor = clr;
+
 				cbm->cgc->buf[y * cols + x] = ch;
 			}
@@ -420,5 +386,9 @@
 				    y - offs.y - cbm->rect.p0.y);
 
-				console_gc_pix_to_charfield(clr, &ch);
+				ch.ch = clr >> 24;
+				ch.flags = CHAR_FLAG_DIRTY;
+				ch.attrs.type = CHAR_ATTR_RGB;
+				ch.attrs.val.rgb.fgcolor = clr ^ 0xffffff;
+				ch.attrs.val.rgb.bgcolor = clr;
 
 				if (clr != cbm->key_color)
@@ -428,5 +398,9 @@
 	} else {
 		/* Color key & colorize */
-		console_gc_pix_to_charfield(cbm->cgc->clr, &ch);
+		ch.ch = 0;
+		ch.flags = CHAR_FLAG_DIRTY;
+		ch.attrs.type = CHAR_ATTR_RGB;
+		ch.attrs.val.rgb.fgcolor = cbm->cgc->clr;
+		ch.attrs.val.rgb.bgcolor = cbm->cgc->clr;
 
 		for (y = crect.p0.y; y < crect.p1.y; y++) {
@@ -461,57 +435,4 @@
 }
 
-/** Get cursor position on console GC.
- *
- * @param arg Console GC
- * @param pos Place to store position
- *
- * @return EOK on success or an error code
- */
-static errno_t console_gc_cursor_get_pos(void *arg, gfx_coord2_t *pos)
-{
-	console_gc_t *cgc = (console_gc_t *) arg;
-	sysarg_t col;
-	sysarg_t row;
-	errno_t rc;
-
-	rc = console_get_pos(cgc->con, &col, &row);
-	if (rc != EOK)
-		return rc;
-
-	pos->x = col;
-	pos->y = row;
-	return EOK;
-}
-
-/** Set cursor position on console GC.
- *
- * @param arg Console GC
- * @param pos New cursor position
- *
- * @return EOK on success or an error code
- */
-static errno_t console_gc_cursor_set_pos(void *arg, gfx_coord2_t *pos)
-{
-	console_gc_t *cgc = (console_gc_t *) arg;
-
-	console_set_pos(cgc->con, pos->x, pos->y);
-	return EOK;
-}
-
-/** Set cursor visibility on console GC.
- *
- * @param arg Console GC
- * @param visible @c true iff cursor should be made visible
- *
- * @return EOK on success or an error code
- */
-static errno_t console_gc_cursor_set_visible(void *arg, bool visible)
-{
-	console_gc_t *cgc = (console_gc_t *) arg;
-
-	console_cursor_visibility(cgc->con, visible);
-	return EOK;
-}
-
 /** @}
  */
Index: uspace/lib/ddev/include/ipc/ddev.h
===================================================================
--- uspace/lib/ddev/include/ipc/ddev.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/ddev/include/ipc/ddev.h	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -33,6 +33,6 @@
  */
 
-#ifndef LIBDDEV_IPC_DDEV_H
-#define LIBDDEV_IPC_DDEV_H
+#ifndef _LIBC_IPC_DDEV_H_
+#define _LIBC_IPC_DDEV_H_
 
 #include <ipc/common.h>
Index: uspace/lib/device/include/bd.h
===================================================================
--- uspace/lib/device/include/bd.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/device/include/bd.h	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup libdevice
+/** @addtogroup libc
  * @{
  */
@@ -33,6 +33,6 @@
  */
 
-#ifndef LIBDEVICE_BD_H
-#define LIBDEVICE_BD_H
+#ifndef _LIBC_BD_H_
+#define _LIBC_BD_H_
 
 #include <async.h>
Index: uspace/lib/device/include/bd_srv.h
===================================================================
--- uspace/lib/device/include/bd_srv.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/device/include/bd_srv.h	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup libdevice
+/** @addtogroup libc
  * @{
  */
@@ -33,6 +33,6 @@
  */
 
-#ifndef LIBDEVICE_BD_SRV_H
-#define LIBDEVICE_BD_SRV_H
+#ifndef _LIBC_BD_SRV_H_
+#define _LIBC_BD_SRV_H_
 
 #include <adt/list.h>
Index: uspace/lib/device/include/device/led_dev.h
===================================================================
--- uspace/lib/device/include/device/led_dev.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/device/include/device/led_dev.h	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup libdevice
+/** @addtogroup libc
  * @{
  */
@@ -33,6 +33,6 @@
  */
 
-#ifndef LIBDEVICE_DEVICE_LED_DEV_H
-#define LIBDEVICE_DEVICE_LED_DEV_H
+#ifndef _LIBC_DEVICE_LED_DEV_H_
+#define _LIBC_DEVICE_LED_DEV_H_
 
 #include <async.h>
Index: uspace/lib/device/include/devman.h
===================================================================
--- uspace/lib/device/include/devman.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/device/include/devman.h	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -28,5 +28,5 @@
  */
 
-/** @addtogroup libdevice
+/** @addtogroup libc
  * @{
  */
@@ -34,6 +34,6 @@
  */
 
-#ifndef LIBDEVICE_DEVMAN_H
-#define LIBDEVICE_DEVMAN_H
+#ifndef _LIBC_DEVMAN_H_
+#define _LIBC_DEVMAN_H_
 
 #include <ipc/devman.h>
Index: uspace/lib/device/include/ieee80211/ieee80211.h
===================================================================
--- uspace/lib/device/include/ieee80211/ieee80211.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/device/include/ieee80211/ieee80211.h	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup libdevice
+/** @addtogroup libc
  *  @{
  */
@@ -35,6 +35,6 @@
  */
 
-#ifndef LIBDEVICE_IEEE80211_H
-#define LIBDEVICE_IEEE80211_H
+#ifndef _LIBC_IEEE80211_H_
+#define _LIBC_IEEE80211_H_
 
 #include <adt/list.h>
Index: uspace/lib/device/include/io/chardev.h
===================================================================
--- uspace/lib/device/include/io/chardev.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/device/include/io/chardev.h	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -27,10 +27,10 @@
  * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
  */
-/** @addtogroup libdevice
+/** @addtogroup libc
  * @{
  */
 
-#ifndef LIBDEVICE_IO_CHARDEV_H
-#define LIBDEVICE_IO_CHARDEV_H
+#ifndef _LIBC_IO_CHARDEV_H_
+#define _LIBC_IO_CHARDEV_H_
 
 #include <async.h>
Index: uspace/lib/device/include/io/chardev_srv.h
===================================================================
--- uspace/lib/device/include/io/chardev_srv.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/device/include/io/chardev_srv.h	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup libdevice
+/** @addtogroup libc
  * @{
  */
@@ -33,6 +33,6 @@
  */
 
-#ifndef LIBDEVICE_IO_CHARDEV_SRV_H
-#define LIBDEVICE_IO_CHARDEV_SRV_H
+#ifndef _LIBC_IO_CHARDEV_SRV_H_
+#define _LIBC_IO_CHARDEV_SRV_H_
 
 #include <adt/list.h>
Index: uspace/lib/device/include/io/label.h
===================================================================
--- uspace/lib/device/include/io/label.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/device/include/io/label.h	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup libdevice
+/** @addtogroup libc
  * @{
  */
@@ -33,6 +33,6 @@
  */
 
-#ifndef LIBDEVICE_IO_LABEL_H
-#define LIBDEVICE_IO_LABEL_H
+#ifndef _LIBC_IO_LABEL_H_
+#define _LIBC_IO_LABEL_H_
 
 #include <types/label.h>
Index: uspace/lib/device/include/io/serial.h
===================================================================
--- uspace/lib/device/include/io/serial.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/device/include/io/serial.h	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup libdevice
+/** @addtogroup libc
  * @{
  */
@@ -33,6 +33,6 @@
  */
 
-#ifndef LIBDEVICE_IO_SERIAL_H
-#define LIBDEVICE_IO_SERIAL_H
+#ifndef _LIBC_IO_SERIAL_H_
+#define _LIBC_IO_SERIAL_H_
 
 #include <async.h>
Index: uspace/lib/device/include/ipc/adb.h
===================================================================
--- uspace/lib/device/include/ipc/adb.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/device/include/ipc/adb.h	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup libdevice
+/** @addtogroup libcipc
  * @{
  */
@@ -34,6 +34,6 @@
  */
 
-#ifndef LIBDEVICE_IPC_ADB_H
-#define LIBDEVICE_IPC_ADB_H
+#ifndef _LIBC_IPC_ADB_H_
+#define _LIBC_IPC_ADB_H_
 
 #include <ipc/common.h>
Index: uspace/lib/device/include/ipc/bd.h
===================================================================
--- uspace/lib/device/include/ipc/bd.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/device/include/ipc/bd.h	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup libdevice
+/** @addtogroup libcipc
  * @{
  */
@@ -33,6 +33,6 @@
  */
 
-#ifndef LIBDEVICE_IPC_BD_H
-#define LIBDEVICE_IPC_BD_H
+#ifndef _LIBC_IPC_BD_H_
+#define _LIBC_IPC_BD_H_
 
 #include <ipc/common.h>
Index: uspace/lib/device/include/ipc/chardev.h
===================================================================
--- uspace/lib/device/include/ipc/chardev.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/device/include/ipc/chardev.h	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup libdevice
+/** @addtogroup libcipc
  * @{
  */
@@ -34,6 +34,6 @@
  */
 
-#ifndef LIBDEVICE_IPC_CHARDEV_H
-#define LIBDEVICE_IPC_CHARDEV_H
+#ifndef _LIBC_IPC_CHARDEV_H_
+#define _LIBC_IPC_CHARDEV_H_
 
 #include <ipc/common.h>
